package org.spagic.bpmn.conversion;

import java.util.Map;

public class Mapping {
	
	private String modelClassName;
	private String key;
	private String keyValues;
	private String binding;
	private boolean ignoreAllProperties;
	
	private Map<String, Property> propertyMap;
	private Map<String, Property> fixedValuesPropertyMap;
	private Map<String, Property> paramArraysPropertyMap;
	
	public Mapping() {
		super();
		this.modelClassName = null;
		this.key = null;
		this.keyValues = null;
		this.binding = null;
		this.propertyMap = null;
		this.fixedValuesPropertyMap = null;
		this.paramArraysPropertyMap = null;
		this.ignoreAllProperties = false;
	}

	public Mapping(String modelClassName, String key, String keyValues, String binding,
			Map<String, Property> propertyMap,
			Map<String, Property> fixedValuesPropertyMap,
			Map<String, Property> paramArraysPropertyMap,
			boolean ignoreAllProperties) {
		super();
		this.modelClassName = modelClassName;
		this.key = key;
		this.keyValues = keyValues;
		this.binding = binding;
		this.propertyMap = propertyMap;
		this.fixedValuesPropertyMap = fixedValuesPropertyMap;
		this.paramArraysPropertyMap = paramArraysPropertyMap;
		this.ignoreAllProperties = ignoreAllProperties;
	}

	public String getModelClassName() {
		return modelClassName;
	}

	public void setModelClassName(String modelClassName) {
		this.modelClassName = modelClassName;
	}

	public String getKey() {
		return key;
	}

	public void setKey(String key) {
		this.key = key;
	}

	public String getKeyValues() {
		return keyValues;
	}

	public void setKeyValues(String keyValues) {
		this.keyValues = keyValues;
	}

	public String getBinding() {
		return binding;
	}

	public void setBinding(String binding) {
		this.binding = binding;
	}

	public Map<String, Property> getPropertyMap() {
		return propertyMap;
	}

	public void setPropertyMap(Map<String, Property> propertyMap) {
		this.propertyMap = propertyMap;
	}

	public Map<String, Property> getFixedValuesPropertyMap() {
		return fixedValuesPropertyMap;
	}

	public void setFixedValuesPropertyMap(
			Map<String, Property> fixedValuesPropertyMap) {
		this.fixedValuesPropertyMap = fixedValuesPropertyMap;
	}

	public Map<String, Property> getParamArraysPropertyMap() {
		return paramArraysPropertyMap;
	}

	public void setParamArraysPropertyMap(
			Map<String, Property> paramArraysPropertyMap) {
		this.paramArraysPropertyMap = paramArraysPropertyMap;
	}

	public boolean isIgnoreAllProperties() {
		return ignoreAllProperties;
	}

	public void setIgnoreAllProperties(boolean ignoreAllProperties) {
		this.ignoreAllProperties = ignoreAllProperties;
	}

}
