package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.jet.taglib.RuntimeTagElement;
import org.eclipse.jet.taglib.TagInfo;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBICXFBC implements JET2Template {
    private static final String _jetns_ws = "org.eclipse.jet.workspaceTags"; //$NON-NLS-1$

    public _jet_JBICXFBC() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$
    
    private static final TagInfo _td_ws_file_119_3 = new TagInfo("ws:file", //$NON-NLS-1$
            119, 3,
            new String[] {
                "template", //$NON-NLS-1$
                "path", //$NON-NLS-1$
            },
            new String[] {
                "templates/servicebindings/cxf-bc-bus.jet", //$NON-NLS-1$
                "{$busCfgFileName}", //$NON-NLS-1$
            } );
    private static final TagInfo _td_ws_copyFile_181_2 = new TagInfo("ws:copyFile", //$NON-NLS-1$
            181, 2,
            new String[] {
                "src", //$NON-NLS-1$
                "srcContext", //$NON-NLS-1$
                "target", //$NON-NLS-1$
            },
            new String[] {
                "{$org.eclipse.jet.resource.project.name}/{$relativeFileNameToProject}", //$NON-NLS-1$
                "workspace", //$NON-NLS-1$
                "{$relativeFileNameToServiceUnit}", //$NON-NLS-1$
            } );

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	String role = "consumer";
   	if (bindingName.equalsIgnoreCase("JBI-CXF-OutputBindingComponent")){
   		role = "provider";
   	}
   	
   	// We Must understand if it's a pipeline transfomer
   	String isPipelineTransformer = JBIJetUtils.getOptionalPropertyValue(aStep, "IsTransformerPipeline", "false");
  

   	
   	boolean flagTransformerPipeline = Boolean.valueOf(isPipelineTransformer);
	if (flagTransformerPipeline){
		role = "provider";
	}
   	
   	String locationURI = JBIJetUtils.getRequiredPropertyValue(aStep, "Uri");
   	String wsdlFile = JBIJetUtils.getOptionalPropertyValue(aStep, "WsdlFile", null);
   	
   	String isSslEnabledString = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagIsSslEnabled", "false");
	Boolean isSslEnabled = Boolean.valueOf(isSslEnabledString);
	
	String isMTOMEnabledString = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagEnableMTOM", "false");
	Boolean isMTOMEnabled = Boolean.valueOf(isMTOMEnabledString);
	
	String isAutogenerateWSDLString = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagAutogenerateWSDL", "true");
	Boolean isAutogenerateWSDL = Boolean.valueOf(isAutogenerateWSDLString);
	String projectName = (String)context.getVariable("org.eclipse.jet.resource.project.name");
	
	
	String isWSAEnabledString = JBIJetUtils.getOptionalPropertyValue(aStep, "FlagEnableWSA", "false");
	Boolean isWSAEnabled = Boolean.valueOf(isWSAEnabledString);
	
	if ((!isAutogenerateWSDL) && (wsdlFile == null)){
		throw new RuntimeException(" if wsdl is not autogenerated it must be provided in WsdlFile property ");
	}
	
	//
	// Fix WSDL Must be done in all case 
	//
	
	if ((!isAutogenerateWSDL) && (wsdlFile != null)) {
		String newWSDLFileName = JBIJetUtils.fixWSDL(aProcess,
													 aStep,
													 destinationStep, 
													 projectName, 
													 wsdlFile, 
												     locationURI,
												     bindingName,
												     flagTransformerPipeline 
													 );
		wsdlFile = newWSDLFileName;
	}
	
	
	//
	// If We're Unsing "JBI-CXF-InputBindingComponent" 
	// With the Autogenerate option, this means we choose 
	// to generate wsdl with spagci studio so we're going to find it 
	//
	if 	   ( bindingName.equalsIgnoreCase("JBI-CXF-InputBindingComponent") 
		&& (   (wsdlFile == null) 
			&& (isAutogenerateWSDL) )) {
		
		wsdlFile = "WsdlFiles/"+SpagicUtils.getStepLocalNamePart(aProcess, aStep) + ".wsdl";
		boolean existWsdlFile = JBIJetUtils.existFileInProject(projectName, wsdlFile);
		if (!existWsdlFile){
			System.out.println(" wsdlFile [" +wsdlFile +"] do not exist ");
			wsdlFile = null;
		}
	}
	
	// CXF-BC Requires WSDL
	if (wsdlFile == null){
		throw new RuntimeException(" Wsdl must be present for cxf-bc ");
	}
	String busCfgFileName = null;
	if (isSslEnabled){
		busCfgFileName = SpagicUtils.getStepLocalNamePart(aProcess, aStep) + "bus.xml";
		context.setVariable("busCfgFileName", busCfgFileName);

        out.write(NL);         
        out.write("\t\t");  //$NON-NLS-1$        
        RuntimeTagElement _jettag_ws_file_119_3 = context.getTagFactory().createRuntimeTag(_jetns_ws, "file", "ws:file", _td_ws_file_119_3); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_ws_file_119_3.setRuntimeParent(null);
        _jettag_ws_file_119_3.setTagInfo(_td_ws_file_119_3);
        _jettag_ws_file_119_3.doStart(context, out);
        _jettag_ws_file_119_3.doEnd();
        out.write(NL);         
	
	}

        out.write(NL);         
        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(role);
        out.write(NL);         
        out.write("\t\t\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
      if ("provider".equals(role)) {
        out.write("\t\t\tlocationURI=\"");  //$NON-NLS-1$        
        out.write(locationURI);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}else{
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
		}
        out.write("\t\t\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         

					if (wsdlFile != null){
						String wsdlresourceString = "classpath:"+JBIJetUtils.getRelativeFileName(wsdlFile);
					   	

        out.write("\t\t\t\t\t   \twsdl=\"");  //$NON-NLS-1$        
        out.write(wsdlresourceString);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t   ");  //$NON-NLS-1$        
        out.write(NL);         
 					}

					if (isMTOMEnabled) {

        out.write("\t\t\t\t\t\tmtomEnabled=\"true\"");  //$NON-NLS-1$        
        out.write(NL);         

					}


					if (busCfgFileName != null) {

        out.write("\t\t\t\t\t\tbusCfg=\"");  //$NON-NLS-1$        
        out.write(busCfgFileName);
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         

					}

        out.write("\t\t\t\t\t>");  //$NON-NLS-1$        
        out.write(NL);         
          if (isWSAEnabled) { 
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<cxfbc:inInterceptors>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t<bean class=\"org.apache.cxf.ws.addressing.soap.MAPCodec\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t</cxfbc:inInterceptors>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t<cxfbc:outInterceptors>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t<bean class=\"org.apache.cxf.ws.addressing.soap.MAPCodec\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t</cxfbc:outInterceptors>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t<cxfbc:inFaultInterceptors>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t<bean class=\"org.apache.cxf.ws.addressing.soap.MAPCodec\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t</cxfbc:inFaultInterceptors>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t<cxfbc:outFaultInterceptors>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t<bean class=\"org.apache.cxf.ws.addressing.soap.MAPCodec\"/>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t</cxfbc:outFaultInterceptors>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
			} 					
        out.write("\t\t\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(role);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
	if (wsdlFile != null) {
	context.setVariable("relativeFileNameToProject", wsdlFile);
	context.setVariable("relativeFileNameToServiceUnit", JBIJetUtils.getRelativeFileName(wsdlFile));
	

        out.write("\t");  //$NON-NLS-1$        
        RuntimeTagElement _jettag_ws_copyFile_181_2 = context.getTagFactory().createRuntimeTag(_jetns_ws, "copyFile", "ws:copyFile", _td_ws_copyFile_181_2); //$NON-NLS-1$ //$NON-NLS-2$
        _jettag_ws_copyFile_181_2.setRuntimeParent(null);
        _jettag_ws_copyFile_181_2.setTagInfo(_td_ws_copyFile_181_2);
        _jettag_ws_copyFile_181_2.doStart(context, out);
        _jettag_ws_copyFile_181_2.doEnd();
        out.write(NL);         
 } 
    }
}
