package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import java.util.*;
import org.spagic.utils.*;
import org.spagic.im.out.jbi.smx.utils.*;

public class _jet_JBIStandardFile implements JET2Template {

    public _jet_JBIStandardFile() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;

	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)context.getVariable("process");
	Step aStep = (Step)context.getVariable("step");
	Step destinationStep = null;
	if (!aStep.getSourceTransitions().isEmpty()){
		destinationStep = aStep.getSourceTransitions().get(0).getTarget();
	}
	
	String bindingName = JBIJetUtils.getRightStepBinding(aStep).getName();
	
	String endpointType = "poller";
	if (bindingName.equalsIgnoreCase("JBI-FileInputBindingComponent")){
   		endpointType = "poller";
   	}else if (bindingName.equalsIgnoreCase("JBI-FileOutputBindingComponent")) {
   		endpointType = "sender";
   	}
   	
   	boolean isEventHandler = bindingName.equalsIgnoreCase("FileEventBindingComponent");
   	
	String marshallerValue = "defaultFileMarshaler";
	
	String marshallerPropertyValue = JBIJetUtils.getOptionalPropertyValue(aStep,"Marshaller","DefaultFileMarshaller");

	if (marshallerPropertyValue.equalsIgnoreCase("BinaryFileMarshaller")){
		marshallerValue = "binaryFileMarshaler";
	}
	
	if (isEventHandler){
		marshallerValue = "eventMarshaller";
	}
	
	String binaryContentType=JBIJetUtils.getOptionalPropertyValue(aStep,"binaryContentType","text/plain");

        out.write(NL);         

if (endpointType.equalsIgnoreCase("poller")){

        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(NL);         
        out.write("\t\t\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\ttargetService=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, destinationStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tfile=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "InputDirectory"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tdeleteFile=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FlagDeletePolledFile", "true"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tperiod=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "PollingPeriod"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t >");  //$NON-NLS-1$        
        out.write(NL);         
       if (!isEventHandler){ 
        out.write("\t\t\t<file:marshaler>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
 if (marshallerValue.equalsIgnoreCase("binaryFileMarshaler")){
        out.write("\t\t\t\t\t\t<sm:contentType>");  //$NON-NLS-1$        
        out.write(binaryContentType);
        out.write("</sm:contentType>");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("\t\t\t\t</sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</file:marshaler>\t\t");  //$NON-NLS-1$        
        out.write(NL);         
       } else {   
        out.write("\t\t\t<property name=\"filter\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t<bean class=\"org.spagic.event.file.filter.SpagicFileEventFilter\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t<property name=\"filterRules\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t<map>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t<entry key=\"ExtensionIs\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t\t\t<value>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "ExtensionIs","*"));
        out.write("</value> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t</entry>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t<entry key=\"FileNameStartWith\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t\t\t<value>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FileNameStartWith","*"));
        out.write("</value> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t</entry>  \t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write("\t\t\t\t\t\t<entry key=\"FileNameEndWith\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t\t\t<value>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FileNameEndWith","*"));
        out.write("</value> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t</entry>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t<entry key=\"FileMinLength\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t\t\t<value>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FileMinLength","0"));
        out.write("</value> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t</entry>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t\t<entry key=\"FileMaxLength\"> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("                \t\t\t<value>");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getOptionalPropertyValue(aStep, "FileMaxLength",""));
        out.write("</value>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t\t\t</entry>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t</map>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t\t</property> ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("            \t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t</property>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t<property name=\"marshaler\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t<bean class=\"org.spagic.event.file.marshaller.SpagicFileEventDynamicMarshaller\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t\t<property name=\"signalEndpointURI\" ");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t\t\t\t\t\t\tvalue=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("        \t\t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("      \t\t</property>");  //$NON-NLS-1$        
        out.write(NL);         
       } 
        out.write("\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
} else {
        out.write("\t\t<");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(NL);         
        out.write("\t\t\tdepends-on=\"spagicProcessProperties\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tservice=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepNameInProcess(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tendpoint=\"");  //$NON-NLS-1$        
        out.write(SpagicUtils.getStepLocalNamePart(aProcess, aStep));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tdirectory=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "OutputDirectory"));
        out.write("\"");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\tappend=\"");  //$NON-NLS-1$        
        out.write(JBIJetUtils.getRequiredPropertyValue(aStep, "AppendContent"));
        out.write("\"\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t >");  //$NON-NLS-1$        
        out.write(NL);         
 if (marshallerValue.equalsIgnoreCase("defaultFileMarshaler")){
        out.write("\t\t \t<file:marshaler>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t</sm:");  //$NON-NLS-1$        
        out.write(marshallerValue);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</file:marshaler>\t");  //$NON-NLS-1$        
        out.write(NL);         
}else if (marshallerValue.equalsIgnoreCase("binaryFileMarshaler")) {
        out.write("\t\t \t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t \t <property name=\"marshaler\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("      \t\t\t\t<bean class=\"org.apache.servicemix.components.util.LenientBinaryFileMarshaler\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("      \t\t\t\t\t<property name=\"contentType\" value=\"");  //$NON-NLS-1$        
        out.write(binaryContentType);
        out.write("\" />");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("      \t\t\t\t</bean>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("   \t\t\t </property>");  //$NON-NLS-1$        
        out.write(NL);         
}
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t</");  //$NON-NLS-1$        
        out.write(context.getVariable("suNameSpacePrefix"));
        out.write(":");  //$NON-NLS-1$        
        out.write(endpointType);
        out.write(">");  //$NON-NLS-1$        
        out.write(NL);         
}
    }
}
