package org.eclipse.jet.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.constants.*;
import org.eclipse.emf.common.util.EMap;
import java.util.*;
import org.spagic.utils.*;

public class _jet_properties implements JET2Template {

    public _jet_properties() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
  
	org.eclipse.stp.im.Process aProcess = (org.eclipse.stp.im.Process)(context.getVariable("process"));
	
	MapProperty processParametersMapProperty = (MapProperty)aProcess.getProperties().get(ImConstants.IM_PROCESS_PARAMETERS);
	if (processParametersMapProperty != null) {
		EMap<String, Property> propertyMap = processParametersMapProperty.getValue();
	
		Property processParameterProperty = null;
	
		// Store all parameters in the map
		for (String key : propertyMap.keySet()) {
			processParameterProperty = propertyMap.get(key);

        out.write(key);
        out.write("=");  //$NON-NLS-1$        
        out.write(processParameterProperty.getValue());
        out.write(NL);         
	 
		}
	}

    }
}
